import math
import os

#Генератор гармоник (2, 3, 5, 7 ...)
from itertools import islice
from math import sqrt
def is_prime(n):
    if (n <= 1):
        return False
    if (n == 2):
        return True
    if (n % 2 == 0):
        return False

    i = 3
    while i <= sqrt(n):
        if n % i == 0:
            return False
        i = i + 2

    return True
def prime_generator():
    n = 1
    while True:
        n += 1
        if is_prime(n):
            yield n

print("H A R M O N A T O R  3 0 0 3 0")
print("Created by MirrorMan2138, all rights are open *COPYLEFT*")
print()

print("Enter Count of Notes")
#n = int(input())
n = 12
print("=", n)
print()

print("Enter Fractional Count of Notes Start Position (11.7 for ex)")
b = float(input())
B =  2 **  (n / b)
print(b, "==>", B)
print()
print("Enter Fractional Count of Notes End Position (12.5 for ex)")
e = float(input())
E =  2 **  (n / e)
print(e, "==>", E)
print()
if b > e:
    b, e = e, b
    B, E = E, B

print("Enter Counting Speed (10-100 is recomend)")
hp = int(input()) * 1000
hs = (B - E) / hp
#hs = 0.00000001
print("=", hp, "==>", hs)
print()

print("Enter Harmonics Count (4 for ex)")
g = int(input())
G = [x for x in islice(prime_generator(), g)]
print("=", g, "==>", G)
print()

print("Enter Cent Weight")
P = 1200
print("=", P)
print()

#print("Enter Cent Error")
#cr = 15
#print("=", cr, "==>", (cr / P) * 100, "%")
#print()

print("Enter 2-nd Harmonica Error Limit")
limit = 100
print("=", limit)
print()

print("Enter to start . . .")
input()

#V = []
W = [0, 0, P]
for v in range(hp):
  os.system('' if os.name == 'nt' else 'clear')
  print("Progress:: ", round((v / hp) * 100, 2), "%")
  print(".")
  print("v")
  print()
  
  print("Base Fractional Harmonica")
  B -= hs
  print("=", B)
  print()
  if B <= 0:
    print("B Error")
    break
  
  print("Fractional Count of Notes in Octave")
  an = (((math.log(2, B) * P)) * n) / P
  print("=", an)
  print()
  
  #Вычисление гармонического сдвига
  print("Harmonics Shift")
  SH = []
  for i in range(len(G)):
    SH.append((math.log(G[i],  B) * P) % P)
    #print(G[i], (math.log(G[i],  B) * 1200) % 1200)
  
  #Вычисление аппроксимации и отклонения сдвига
  minP = 0
  R = []
  for i in range(len(SH)):
    minT = P
    for j in range(n + 1):
      if ((SH[i] - (P / n) * j)**2)**0.5 <= (minT**2)**0.5:
        minT = ((SH[i] - (P / n) * j))
        minP = j * (P / n)
        #print(SH[i], P, n, j, minT, minP)    
    print(G[i], "||", (math.log(G[i], B) * P) % P, "::", minP, "::", ((((math.log(G[i], B) * P) % P) - minP)))      
    rrr = ((((math.log(G[i], B)) * P) % P) - minP)
    if G[i]==2:
        if (((rrr)**2)**0.5) > limit:
            R.append(1000000000000)
        else:
            R.append(rrr)
    else:
        R.append(rrr)	

  #Позиция минимального отклонения 
  w = 0
  for k in range(len(R)):
    if (R[k]**2)**0.5 > (w**2)**0.5:
      w = R[k]
  #print()
  #print("Cent Error")
  #print("=", w)

  if (w**2)**0.5 < (W[-1]**2)**0.5:
    W[-1] = w
    W[-2] = B
    W[-3] = (((math.log(2, B) * P)) * n) / P
  

  print()
  print("Result in progress::")
  print(".")
  print("v")

  print()
  print("Best Base Fractional Harmonica")
  print("=", W[-2])
  
  print()
  print("Best Fractional Count of Notes in Octave")
  print("=", W[-3])

  print()
  print("Best Cent Error") 
  print("=", W[-1])
  
  #Проверка на минимальное указанное отклонение в центах
  #key = 0
  #for k in range(len(R)):
    #if R[k] > cr:
      #key = 1
  #if key == 0:
    #Запись результатов
    #V.append([(((math.log(2, B) * P)) * n) / P, B, w])

#Выводим результат
os.system('cls' if os.name == 'nt' else 'clear')

print()
print("Progress::  END")
print("Result::")
print(".")
print("v")

print()
print("Best Base Fractional Harmonica")
print("=", W[-2])

print()
print("Best Fractional Count of Notes in Octave")
print("=", W[-3])

B = W[-2]

#Вычисление лучшего гармонического сдвига
print()
print("Best Harmonics Shift")
SH = []
for i in range(len(G)):
  SH.append((math.log(G[i],  B) * P) % P)
  #print(G[i], (math.log(G[i],  B) * 1200) % 1200)

#Всё те же вычисления аппроксимации и отклонения сдвига, которое я не вывел в функцию =P
minP = 0
R = []
for i in range(len(SH)):
  minT = P
  for j in range(n + 1):
    if ((SH[i] - (P / n) * j)**2)**0.5 <= (minT**2)**0.5:
      minT = ((SH[i] - (P / n) * j))
      minP = j * (P / n)
      #print(SH[i], P, n, j, minT, minP)    
  print(G[i], "||", (math.log(G[i], B) * P) % P, "::", minP, "::", ((((math.log(G[i], B) * P) % P) - minP)))
  R.append(((((math.log(G[i], B) * P) % P) - minP)))

print()
print("Best Cent Error") 
print("=", W[-1])

#print()
#print("Enter to All Fractional Harmonics")
#input()
#print("=", V)
#input()

print()
print("Tripple Enter to Exit")
input()
input()
input()
print("Exit")
